package de.mannheim.uni.expansion.tablefusion.core.matching.impl.reference;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.matching.correspondences.Correspondence;
import de.mannheim.uni.matching.dbpedia.model.TableRow;
import de.mannheim.uni.similarity.matrix.SimilarityMatrix;
import de.mannheim.uni.tableprocessor.model.Table;

public class MatchedColumnData {

	@Deprecated
	private final SimilarityMatrix<Table> classSimilarity;
	@Deprecated
	private final SimilarityMatrix<TableRow> refinedCandidateSimilarity;
	private final Collection<Correspondence<TableRow>> refinedInstanceMappings;

	public MatchedColumnData(SimilarityMatrix<Table> classSimilarity, SimilarityMatrix<TableRow> similarityMatrix,
			Collection<Correspondence<TableRow>> refinedInstanceMappings) {
		this.classSimilarity = classSimilarity;
		this.refinedCandidateSimilarity = similarityMatrix;
		this.refinedInstanceMappings = refinedInstanceMappings;
	}

	public SimilarityMatrix<Table> getClassSimilarity() {
		return classSimilarity;
	}

	public SimilarityMatrix<TableRow> getRefinedCandidateSimilarity() {
		return refinedCandidateSimilarity;
	}

	public Collection<Correspondence<TableRow>> getRefinedInstanceMappings() {
		return refinedInstanceMappings;
	}

	@Deprecated
	public ClassId getHighestClass() {
		Double maxSimilarity = null;
		Table classTable = null;

		for (Table first : classSimilarity.getFirstDimension()) {
			for (Table second : classSimilarity.getMatches(first)) {
				if (maxSimilarity == null) {
					maxSimilarity = classSimilarity.get(first, second);
					classTable = second;
				} else {
					double sim = classSimilarity.get(first, second);
					if (sim > maxSimilarity) {
						maxSimilarity = sim;
						classTable = second;
					}

				}
			}
		}

		String header = classTable.getHeader();

		return new ClassId(header.substring(0, header.length() - 4));
	}

	/**
	 * Uses the refined instance mappings to return a Map where row index is
	 * mapped to the matched instance
	 * 
	 * @return
	 */
	public Map<Integer, InstanceId> getRowInstanceMatches() {

		Map<Integer, InstanceId> map = new HashMap<Integer, InstanceId>();

		for (Correspondence<TableRow> c : this.refinedInstanceMappings) {
			Integer index = c.getFirst().getRowIndex();
			String key = c.getSecond().getKey().toString();
			InstanceId instance = InstanceId.fromString(key);

			map.put(index, instance);
		}

		return map;
	}
}
