package de.mannheim.uni.expansion.data;

import java.rmi.RemoteException;
import java.util.concurrent.ConcurrentHashMap;

public class RemoteInterfaceWithCache {
	protected <K> Object cacheGetter(ConcurrentHashMap<K, Object> map, K key, ValueGetter<K> valueGetter) {
		try {
			Object o = map.get(key);
			if (o == null) {
				o = valueGetter.getValue(key);

				if (o == null) {
					map.putIfAbsent(key, nullReplacementString);
					return null;
				} else {
					map.putIfAbsent(key, o);
					return o;
				}
			} else {
				if (o == nullReplacementString) {
					return null;
				} else {
					return o;
				}
			}

		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	String nullReplacementString = new String("NULL REPLACEMENT STRING");

	@FunctionalInterface
	protected interface ValueGetter<K> {
		Object getValue(K key) throws RemoteException;
	}

}
