package de.mannheim.uni.expansion.data.dbpedia.adapter;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class DBPediaLoadCache {
	Map<ClassId, ClassId> classCache = new ConcurrentHashMap<ClassId, ClassId>();
	Map<InstanceId, InstanceId> instanceCache = new ConcurrentHashMap<InstanceId, InstanceId>();
	Map<PropertyId, PropertyId> propertyCache = new ConcurrentHashMap<PropertyId, PropertyId>();
	Map<Object, Object> valueCache = new ConcurrentHashMap<Object, Object>();

	public ClassId getFromCache(ClassId dBpediaClass) {
		ClassId cached = classCache.get(dBpediaClass);
		if (cached == null) {
			ClassId ret = classCache.putIfAbsent(dBpediaClass, dBpediaClass);
			if (ret == null)
				return dBpediaClass;
			else
				return ret;
		} else {
			return cached;
		}
	}

	public PropertyId getFromCache(PropertyId propertyId) {
		PropertyId cached = propertyCache.get(propertyId);
		if (cached == null) {
			PropertyId ret = propertyCache.putIfAbsent(propertyId, propertyId);
			if (ret == null)
				return propertyId;
			else
				return ret;
		} else {
			return cached;
		}
	}

	public InstanceId getFromCache(InstanceId instanceId) {
		InstanceId cached = instanceCache.get(instanceId);
		if (cached == null) {
			InstanceId ret = instanceCache.putIfAbsent(instanceId, instanceId);
			if (ret == null)
				return instanceId;
			else
				return ret;
		} else {
			return cached;
		}
	}

	public Object getFromCache(Object object) {
		Object cached = valueCache.get(object);
		if (cached == null) {
			Object ret = valueCache.putIfAbsent(object, object);
			if (ret == null)
				return object;
			else
				return ret;
		} else {
			return cached;
		}
	}

}