package de.mannheim.uni.expansion.data.dbpedia.adapter.csv;

import java.io.IOException;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.dbpedia.repository.DBpediaRepositoryNew;

public class DBpediaRepositoryCSVAdapter {

	private final DBPediaRepositoryCSVWriter writer;
	private final DBPediaRepositoryCSVReader reader;

	@Inject
	public DBpediaRepositoryCSVAdapter(DBPediaRepositoryCSVWriter writer, DBPediaRepositoryCSVReader reader) {
		this.writer = writer;
		this.reader = reader;
	}

	public void write(DBpediaRepositoryNew repository, String folder, boolean newValueFormat) throws IOException {
		writer.write(repository, folder, newValueFormat);
	}

	public DBpediaRepositoryNew read(String folder, boolean newValueFormat) throws IOException, ClassNotFoundException, InterruptedException {
		return reader.read(folder, newValueFormat);
	}

	// public BidiMap<PropertyId, Integer> getFromCache(Map<ClassId,
	// BidiMap<PropertyId, Integer>> map, ClassId classId) {
	// BidiMap<PropertyId, Integer> bidiMap = map.get(classId);
	// if (bidiMap == null) {
	// bidiMap = new DualHashBidiMap<PropertyId, Integer>();
	// BidiMap<PropertyId, Integer> ret = map.putIfAbsent(classId, bidiMap);
	// if (ret == null)
	// return bidiMap;
	// else
	// return map.get(classId);
	// } else {
	// return bidiMap;
	// }
	// }

	// public <E, T> BidiMap<T, Integer> getFromCache(Map<E, BidiMap<T,
	// Integer>> map, E key) {
	// BidiMap<T, Integer> bidiMap = map.get(key);
	// if (bidiMap == null) {
	// bidiMap = new DualHashBidiMap<T, Integer>();
	// BidiMap<T, Integer> ret = map.putIfAbsent(key, bidiMap);
	// if (ret == null)
	// return bidiMap;
	// else
	// return ret;
	// } else {
	// return bidiMap;
	// }
	// }

}
