package de.mannheim.uni.expansion.data.dbpedia.adapter.kryo;

import java.io.File;
import java.io.IOException;
import java.util.Map;
import java.util.Map.Entry;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.CountDownLatch;

import org.apache.commons.collections4.BidiMap;
import org.apache.commons.collections4.bidimap.DualHashBidiMap;

import de.mannheim.uni.expansion.data.dbpedia.adapter.DBPediaLoadCache;
import de.mannheim.uni.expansion.data.dbpedia.adapter.csv.DBpediaRepositoryCSVAdapter;
import de.mannheim.uni.expansion.data.dbpedia.repository.DBpediaRepositoryNew;
import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.ValueId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId.FileEnding;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.matching.dbpedia.model.MatchingData;
import de.mannheim.uni.matching.dbpedia.model.MatchingParameters;
import de.mannheim.uni.tableprocessor.model.Table;
import de.mannheim.uni.tableprocessor.model.TableColumn;
import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

public class CreateDBPediaRepositoryFromKryo {
	private final String dbpediaKryoPath;
	private final String dbpediaRepositoryPath;
	private final MatchingParameters mp;
	private final FileEnding fileEnding;
	private final DBpediaRepositoryCSVAdapter csvAdapter;
	MatchingData md = new MatchingData();

	public CreateDBPediaRepositoryFromKryo(String dbpediaRepositoryPath, String dbpediaKryoPath, FileEnding fileEnding, MatchingParameters mp,
			DBpediaRepositoryCSVAdapter csvAdapter) {
		this.dbpediaRepositoryPath = dbpediaRepositoryPath;
		this.dbpediaKryoPath = dbpediaKryoPath;
		this.mp = mp;
		this.fileEnding = fileEnding;
		this.csvAdapter = csvAdapter;
	}

	// public static void main(String[] args) {
	//
	// String dataHome = "C:/Users/yaser/dev/data";
	//
	// if (args.length > 0 && args[0] != null && !args[0].equals("")) {
	// dataHome = args[0];
	// }
	//
	// String dbpediaFile = dataHome + "/serialised_kryo_subset.bin";
	// if (args.length > 1 && args[1] != null && args[1].equals("full")) {
	// dbpediaFile = dataHome + "/serialised_kryo.bin";
	// System.out.println("Reading Full Dataset");
	// }
	//
	// // String uriIndexPath = "C:/Users/yaser/dev/data/index";
	//
	// boolean useUnits = true;
	//
	// MatchingParameters mp = new MatchingParameters();
	// mp.setUseUnitDetection(useUnits);
	// mp.setFastJoinDelta(1); // = edit distance threshold
	// mp.setFastJoinTau(1); // = jaccard threshold
	//
	// MatchingData md = new MatchingData();
	// md.loadDBpedia(dbpediaFile, mp);
	//
	// bucket.upsert(SerializableDocument.create("123", new Date()));
	// bucket.upsert(SerializableDocument.create("124", "fsadfsadf"));
	//
	// CreateDBPediaRepository createDBPediaRepository = new
	// CreateDBPediaRepository();
	// createDBPediaRepository.run(bucket, md);
	//
	// bucket.close();
	// }

	Runnable POISEN = new Runnable() {

		@Override
		public void run() {
			// TODO Auto-generated method stub

		}
	};

	Runnable PRODCUER_POISEN = new Runnable() {

		@Override
		public void run() {
			// TODO Auto-generated method stub

		}
	};

	int numOfConsumerThreads = 24;
	int numOfProducerThreads = 8;

	int runQueueMax = 3;

	// private void insert(SerializableDocument doc) {
	// try {
	//
	// bucket.upsert(doc);
	//
	// } catch (RuntimeException e) {
	// System.out.println(e.toString());
	// insert(doc);
	// }
	// }

	public DBpediaRepositoryNew run() {
		System.out.println("Loading DBpedia ... ");
		System.err.println("Loading DBpedia ... ");
		DBpediaRepositoryNew repository;

		File f2 = new File(dbpediaRepositoryPath);
		if ((f2.exists() && f2.isDirectory() && f2.list().length > 4)) {

			try {
				repository = csvAdapter.read(dbpediaRepositoryPath, false);

				System.out.println("Loading DBpedia ... done");
				System.err.println("Loading DBpedia ... done");
			} catch (IOException | ClassNotFoundException | InterruptedException e) {
				throw new RuntimeException(e);
			}
		} else {

			md.loadDBpedia(dbpediaKryoPath, mp);
			ArrayBlockingQueue<Runnable> producerQueue = new ArrayBlockingQueue<Runnable>(runQueueMax * 2, true);

			CountDownLatch prodcuerLatch = new CountDownLatch(numOfProducerThreads);

			Runnable producerWorker = new Runnable() {

				@Override
				public void run() {
					System.out.println("Producer " + Thread.currentThread().getName() + " START");
					while (true) {

						Runnable task;
						try {
							task = producerQueue.take();

							if (task == PRODCUER_POISEN) {
								break;
							} else {
								task.run();
							}
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}
					System.out.println("Producer " + Thread.currentThread().getName() + " END");
					prodcuerLatch.countDown();

				}
			};

			for (int i = 0; i < numOfProducerThreads; i++) {
				Thread thread = new Thread(producerWorker);
				thread.start();
			}

			ArrayBlockingQueue<Runnable> queue = new ArrayBlockingQueue<Runnable>(numOfConsumerThreads * 2, true);

			CountDownLatch latch = new CountDownLatch(numOfConsumerThreads);

			Runnable queueWorker = new Runnable() {

				@Override
				public void run() {
					System.out.println("Consumer " + Thread.currentThread().getName() + " START");
					while (true) {

						Runnable doc;
						try {
							doc = queue.take();

							if (doc == POISEN) {
								break;
							} else {
								doc.run();
							}
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}
					System.out.println("Consumer " + Thread.currentThread().getName() + " END");
					latch.countDown();

				}
			};

			for (int i = 0; i < numOfConsumerThreads; i++) {
				Thread thread = new Thread(queueWorker);
				thread.start();
			}

			DBPediaLoadCache cache = new DBPediaLoadCache();
			final Map<ClassId, Integer> tableIndex = new ConcurrentHashMap<ClassId, Integer>();

			final Map<ClassId, BidiMap<PropertyId, Integer>> propertyIndices = new ConcurrentHashMap<ClassId, BidiMap<PropertyId, Integer>>();

			final Map<ClassId, BidiMap<InstanceId, Integer>> instanceIndices = new ConcurrentHashMap<ClassId, BidiMap<InstanceId, Integer>>();

			final ConcurrentHashMap<ValueId, Object> values = new ConcurrentHashMap<ValueId, Object>(16, 0.75F, numOfProducerThreads);

			final Map<ClassPropertyId, ColumnDataType> columnDataTypes = new ConcurrentHashMap<ClassPropertyId, ColumnDataType>();
			final Map<ClassId, PropertyId> classKeys = new ConcurrentHashMap<ClassId, PropertyId>();

			int tCounter = 0;

			for (Table t : md.getDbpediaTables()) {

				try {

					final int tCounterFinal = tCounter;
					System.out.println(tCounter);

					TableColumn key = null;

					for (TableColumn tc : t.getColumns()) {
						if (tc.getHeader().equals("URI")) {
							key = tc;
							break;
						}
					}

					if (key != null) {

						ClassId dbPediaClass = cache.getFromCache(ClassId.fromString(t.getHeader(), fileEnding));

						tableIndex.put(dbPediaClass, tCounter);

						BidiMap<PropertyId, Integer> columns = new DualHashBidiMap<PropertyId, Integer>();
						int c = 0;
						for (TableColumn column : t.getColumns()) {

							PropertyId dbPediaProperty = cache.getFromCache(new PropertyId(column.getURI()));

							columns.put(dbPediaProperty, c);

							if (column.getHeader().equals("URI")) {
								classKeys.put(dbPediaClass, dbPediaProperty);
							}

							c++;
						}

						propertyIndices.put(dbPediaClass, columns);

						BidiMap<InstanceId, Integer> instances = new DualHashBidiMap<InstanceId, Integer>();

						for (Entry<Integer, Object> instance : key.getValues().entrySet()) {
							InstanceId dbPediaInstance = cache.getFromCache(new InstanceId(instance.getValue().toString()));

							instances.put(dbPediaInstance, instance.getKey());

						}

						instanceIndices.put(dbPediaClass, instances);

						int columnSize = t.getColumns().size();
						for (int cCounter = 0; cCounter < columnSize; cCounter++) {

							final int cCounterFinal = cCounter;
							Runnable r = () -> {

								TableColumn column = t.getColumns().get(cCounterFinal);

								for (Entry<Integer, Object> e : column.getValues().entrySet()) {

									int instanceCounterFinal = e.getKey();

									InstanceId dbPediaInstance = instances.getKey(instanceCounterFinal);

									Object value = e.getValue();

									if (value != null && dbPediaInstance != null) {

										PropertyId propertyId = cache.getFromCache(new PropertyId(column.getURI()));
										ValueId valueId = new ValueId(dbPediaInstance, propertyId);

										String fullKey = "DP_" + tCounterFinal + "_" + instanceCounterFinal + "_" + cCounterFinal;

										values.put(valueId, value);

										if (column.getDataType() == ColumnDataType.list) {
											column.setDataType(ColumnDataType.string);
										}

										columnDataTypes.put(new ClassPropertyId(dbPediaClass, propertyId), column.getDataType());

										// valueExists.add(new
										// TripleId(dbPediaClass, propertyId,
										// dbPediaInstance));
									}

								}

							};

							producerQueue.put(r);

						}

					} else {
						System.out.println("WARNING: Table without key");
					}

					tCounter++;

				} catch (Exception e) {
					e.printStackTrace();
				}

			}

			for (int i = 0; i < numOfProducerThreads; i++) {
				try {
					producerQueue.put(PRODCUER_POISEN);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

			try {
				prodcuerLatch.await();
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}

			for (int i = 0; i < numOfConsumerThreads; i++) {
				try {
					queue.put(POISEN);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

			try {
				latch.await();
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}

			md = null;
			System.gc();

			System.out.println("Loading DBpedia ... done");
			System.err.println("Loading DBpedia ... done");
			repository = new DBpediaRepositoryNew(tableIndex, propertyIndices, instanceIndices, columnDataTypes, classKeys, values, null, null, null);

			try {
				csvAdapter.write(repository, dbpediaRepositoryPath, true);
				System.out.println("done.");

			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		return repository;

	}

}
