package de.mannheim.uni.expansion.data.dbpedia.kbtables;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;

import de.mannheim.uni.expansion.data.dbpedia.repository.DBpediaRepositoryNewInterface;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.tableprocessor.model.TableColumn;

public class RepositoryColumnList implements List<TableColumn> {

	private final DBpediaRepositoryNewInterface dbPediaRepository;
	private final ClassId classId;

	public RepositoryColumnList(DBpediaRepositoryNewInterface dbPediaRepository, ClassId dbPediaClass) {
		this.dbPediaRepository = dbPediaRepository;
		this.classId = dbPediaClass;

	}

	@Override
	public boolean add(TableColumn e) {
		throw new UnsupportedOperationException();
	}

	@Override
	public void add(int index, TableColumn element) {
		throw new UnsupportedOperationException();

	}

	@Override
	public boolean addAll(Collection<? extends TableColumn> c) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean addAll(int index, Collection<? extends TableColumn> c) {
		throw new UnsupportedOperationException();
	}

	@Override
	public void clear() {
		throw new UnsupportedOperationException();

	}

	@Override
	public boolean contains(Object o) {
		if (o instanceof RepositoryTableColumn) {
			RepositoryTableColumn column = (RepositoryTableColumn) o;

			if (column.getDbPediaClass().equals(this.classId)) {
				return true;
			} else {
				return false;
			}
		}

		else
			return false;
	}

	@Override
	public boolean containsAll(Collection<?> c) {
		throw new UnsupportedOperationException();
	}

	@Override
	public TableColumn get(int index) {
		PropertyId propertyId = dbPediaRepository.getProperty(classId, index);

		return new RepositoryTableColumn(dbPediaRepository, classId, propertyId);
	}

	@Override
	public int indexOf(Object o) {
		if (o instanceof RepositoryTableColumn) {
			RepositoryTableColumn column = (RepositoryTableColumn) o;

			if (column.getDbPediaClass().equals(this.classId)) {
				return this.dbPediaRepository.getPropertyIndex(this.classId, column.getdBpediaProperty());
			} else {
				return -1;
			}
		}

		else
			return -1;
	}

	@Override
	public boolean isEmpty() {
		throw new UnsupportedOperationException();
	}

	@Override
	public Iterator<TableColumn> iterator() {

		final Iterator<Integer> indexIterator = dbPediaRepository.getProperties(classId).values().iterator();

		return new Iterator<TableColumn>() {

			@Override
			public TableColumn next() {
				return new RepositoryTableColumn(dbPediaRepository, classId, dbPediaRepository.getProperties(classId).getKey(indexIterator.next()));
			}

			@Override
			public boolean hasNext() {
				return indexIterator.hasNext();
			}
		};
	}

	@Override
	public int lastIndexOf(Object o) {
		throw new UnsupportedOperationException();
	}

	@Override
	public ListIterator<TableColumn> listIterator() {
		throw new UnsupportedOperationException();
	}

	@Override
	public ListIterator<TableColumn> listIterator(int index) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean remove(Object o) {
		throw new UnsupportedOperationException();
	}

	@Override
	public TableColumn remove(int index) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean removeAll(Collection<?> c) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean retainAll(Collection<?> c) {
		throw new UnsupportedOperationException();
	}

	@Override
	public TableColumn set(int index, TableColumn element) {
		throw new UnsupportedOperationException();
	}

	@Override
	public int size() {
		return dbPediaRepository.getProperties(classId).size();
	}

	@Override
	public List<TableColumn> subList(int fromIndex, int toIndex) {
		throw new UnsupportedOperationException();
	}

	@Override
	public Object[] toArray() {
		throw new UnsupportedOperationException();
	}

	@Override
	public <T> T[] toArray(T[] a) {
		throw new UnsupportedOperationException();
	}

}
