package de.mannheim.uni.expansion.data.dbpedia.kbtables;

import java.util.List;

import de.mannheim.uni.expansion.data.dbpedia.repository.DBpediaRepositoryNewInterface;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.tableprocessor.model.Table;
import de.mannheim.uni.tableprocessor.model.TableColumn;

public class RepositoryTable extends Table {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private final DBpediaRepositoryNewInterface repository;
	private final ClassId classId;

	public RepositoryTable(DBpediaRepositoryNewInterface dbPediaRepository, ClassId classId) {
		this.repository = dbPediaRepository;
		this.classId = classId;
		this.setFullPath(classId.toString());
	}

	public List<TableColumn> getColumns() {
		return new RepositoryColumnList(repository, classId);
	}

	public TableColumn getKey() {

		PropertyId propertyId = repository.getClassKey(classId);

		return new RepositoryTableColumn(repository, classId, propertyId);
	}

	public int getKeyIndex() {
		Integer keyIndex = repository.getPropertyIndex(classId, repository.getClassKey(classId));
		if (keyIndex == null) {
			return -1;
		} else {
			return keyIndex;
		}
	}

	public String getHeader() {
		return classId.getFinalPart();
	}
}
