package de.mannheim.uni.expansion.data.dbpedia.kbtables;

import java.util.Map;

import de.mannheim.uni.expansion.data.dbpedia.repository.DBpediaRepositoryNewInterface;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.tableprocessor.model.TableColumn;

public class RepositoryTableColumn extends TableColumn {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final DBpediaRepositoryNewInterface dbPediaRepository;
	private final ClassId dbPediaClass;
	private final PropertyId dBpediaProperty;

	public RepositoryTableColumn(DBpediaRepositoryNewInterface dbPediaRepository, ClassId dbPediaClass, PropertyId dbPediaProperty) {
		super(new RepositoryTable(dbPediaRepository, dbPediaClass));
		this.dbPediaRepository = dbPediaRepository;
		this.dbPediaClass = dbPediaClass;
		this.dBpediaProperty = dbPediaProperty;
	}

	public Map<Integer, Object> getValues() {
		return new RepositoryTableColumnValues(dbPediaRepository, dbPediaClass, dBpediaProperty);
	}

	@Override
	public ColumnDataType getDataType() {
		// FIXME: THIS IS NOT AN APPROAPRIATE FIX
		if (isKey())
			return ColumnDataType.string;
		ColumnDataType cdt = dbPediaRepository.getDataType(dbPediaClass, dBpediaProperty);
		if (cdt == null) {
			System.out.println("EVEN IN RepositoryTableColumn WE NEED ONTOLOGY");
		}
		return cdt;
	}

	@Override
	public boolean isKey() {
		return dbPediaRepository.isKey(dbPediaClass, dBpediaProperty);
	}

	public DBpediaRepositoryNewInterface getDbPediaRepository() {
		return dbPediaRepository;
	}

	public ClassId getDbPediaClass() {
		return dbPediaClass;
	}

	public PropertyId getdBpediaProperty() {
		return dBpediaProperty;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((dBpediaProperty == null) ? 0 : dBpediaProperty.hashCode());
		result = prime * result + ((dbPediaClass == null) ? 0 : dbPediaClass.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RepositoryTableColumn other = (RepositoryTableColumn) obj;
		if (dBpediaProperty == null) {
			if (other.dBpediaProperty != null)
				return false;
		} else if (!dBpediaProperty.equals(other.dBpediaProperty))
			return false;
		if (dbPediaClass == null) {
			if (other.dbPediaClass != null)
				return false;
		} else if (!dbPediaClass.equals(other.dbPediaClass))
			return false;
		return true;
	}

	public String getURI() {
		return dBpediaProperty.getAsString();
	}

}
