package de.mannheim.uni.expansion.data.dbpedia.kbtables;

import de.mannheim.uni.expansion.data.dbpedia.repository.DBpediaRepositoryNewInterface;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.matching.dbpedia.model.TableRow;

public class RepsitoryTableRow extends TableRow {

	private final DBpediaRepositoryNewInterface dbPediaRepository;
	private final ClassId classId;
	private final InstanceId instanceId;

	public RepsitoryTableRow(DBpediaRepositoryNewInterface dbPediaRepository, ClassId classId, InstanceId instanceId, int rowIndex) {
		super(new RepositoryTable(dbPediaRepository, classId), rowIndex, rowIndex + dbPediaRepository.getNumberOfHeaderRows(classId));
		this.dbPediaRepository = dbPediaRepository;
		this.classId = classId;
		this.instanceId = instanceId;
	}

	public RepsitoryTableRow(DBpediaRepositoryNewInterface dbPediaRepository, ClassId classId, InstanceId instanceId) {
		this(dbPediaRepository, classId, instanceId, dbPediaRepository.getInstanceIndex(instanceId, classId));
	}

	public Object getKey() {
		return instanceId.getReadableString();

	}

	public Object getURI() {
		return instanceId.toString();
	}

}
