package de.mannheim.uni.expansion.data.dbpedia.repository;

import java.util.Map;
import java.util.Set;

import org.apache.commons.collections4.BidiMap;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.ListType;
import de.mannheim.uni.expansion.data.ontology.model.TripleId;
import de.mannheim.uni.expansion.data.ontology.model.ValueId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

public interface DBpediaRepositoryNewInterface {

	Set<ClassId> getClasses();

	BidiMap<InstanceId, Integer> getInstances(ClassId currentTable);

	int getTotalNumberOfColumns();

	BidiMap<PropertyId, Integer> getProperties(ClassId currentTable);

	int getTotalNumberOfClasses();

	int getNumberOfRows(ClassId dbPediaClass);

	int getNumberOfColumns(ClassId classId);

	InstanceId getInstance(ClassId dbPediaClass, int index);

	int getNumberOfHeaderRows(ClassId currentTable);

	int getInstanceIndex(InstanceId instanceId, ClassId classId);

	int getNumberOfInstances();

	int getNumberOfInstances(ClassId classId);

	Set<ClassId> getClasses(InstanceId instanceId);

	PropertyId getProperty(ClassId classId, int index);

	ColumnDataType getDataType(ClassId dbPediaClass, PropertyId dBpediaProperty);

	boolean isKey(ClassId dbPediaClass, PropertyId dBpediaProperty);

	PropertyId getClassKey(ClassId classId);

	boolean hasValue(TripleId tripleId);

	boolean hasValue(ValueId valueId);

	boolean hasValue(ClassId classId, PropertyId propertyId, InstanceId instanceId);

	boolean hasValue(InstanceId instanceId, PropertyId propertyId);

	Set<InstanceId> getInstances(ClassId classId, PropertyId propertyId);

	int getTotalNumberOfRows();

	Object getValue(ValueId key);

	Object getValue(ClassId dbPediaClass, InstanceId dbPediaInstance, PropertyId propertyKey);

	Object getValue(TripleId key);

	boolean hasClass(ClassId classId);

	PropertyId getPropertyFromShortName(ClassId classId, String propertyName);

	boolean hasInstance(ClassId classId, InstanceId instanceId);

	boolean propertyExists(ClassId classId, PropertyId propertyId);

	boolean isListType(ClassPropertyId classPropertyId);

	boolean isListType(ListType listType, ClassPropertyId classPropertyId);

	int getInstancesSize(ClassId classId, PropertyId propertyId);

	Map<ClassId, BidiMap<InstanceId, Integer>> getInstanceIndices();

	Map<ClassId, BidiMap<PropertyId, Integer>> getPropertyIndices();

	Map<ClassId, Integer> getTableIndeces();

	Set<ClassPropertyId> getListTypes();

	Set<ClassPropertyId> getListTypes(ListType listType);

	Map<ValueId, Object> getValues();

	Map<ClassId, PropertyId> getClassKeys();

	Map<ClassPropertyId, ColumnDataType> getColumnDataTypes();

	Map<ClassPropertyId, Set<InstanceId>> getInstancesPerClassProperty();

	Integer getPropertyIndex(ClassId classId, PropertyId propertyId);

}
