package de.mannheim.uni.expansion.data.dbpedia.repository;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Map;
import java.util.Set;

import org.apache.commons.collections4.BidiMap;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.ListType;
import de.mannheim.uni.expansion.data.ontology.model.TripleId;
import de.mannheim.uni.expansion.data.ontology.model.ValueId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

public interface DBpediaRepositoryNewInterfaceRemote extends Remote {

	Set<ClassId> getClasses() throws RemoteException;

	BidiMap<InstanceId, Integer> getInstances(ClassId currentTable) throws RemoteException;

	int getTotalNumberOfColumns() throws RemoteException;

	BidiMap<PropertyId, Integer> getProperties(ClassId currentTable) throws RemoteException;

	int getTotalNumberOfClasses() throws RemoteException;

	int getNumberOfRows(ClassId dbPediaClass) throws RemoteException;

	int getNumberOfColumns(ClassId classId) throws RemoteException;

	InstanceId getInstance(ClassId dbPediaClass, int index) throws RemoteException;

	int getNumberOfHeaderRows(ClassId currentTable) throws RemoteException;

	int getInstanceIndex(InstanceId instanceId, ClassId classId) throws RemoteException;

	int getNumberOfInstances() throws RemoteException;

	int getNumberOfInstances(ClassId classId) throws RemoteException;

	Set<ClassId> getClasses(InstanceId instanceId) throws RemoteException;

	PropertyId getProperty(ClassId classId, int index) throws RemoteException;

	ColumnDataType getDataType(ClassId dbPediaClass, PropertyId dBpediaProperty) throws RemoteException;

	boolean isKey(ClassId dbPediaClass, PropertyId dBpediaProperty) throws RemoteException;

	PropertyId getClassKey(ClassId classId) throws RemoteException;

	boolean hasValue(TripleId tripleId) throws RemoteException;

	boolean hasValue(ValueId valueId) throws RemoteException;

	boolean hasValue(ClassId classId, PropertyId propertyId, InstanceId instanceId) throws RemoteException;

	boolean hasValue(InstanceId instanceId, PropertyId propertyId) throws RemoteException;

	Set<InstanceId> getInstances(ClassId classId, PropertyId propertyId) throws RemoteException;

	int getTotalNumberOfRows() throws RemoteException;

	Object getValue(ValueId key) throws RemoteException;

	Object getValue(ClassId dbPediaClass, InstanceId dbPediaInstance, PropertyId propertyKey) throws RemoteException;

	PropertyId getPropertyFromShortName(ClassId classId, String propertyName) throws RemoteException;

	Object getValue(TripleId key) throws RemoteException;

	boolean hasClass(ClassId classId) throws RemoteException;

	boolean propertyExists(ClassId classId, PropertyId propertyId) throws RemoteException;

	boolean isListType(ClassPropertyId classPropertyId) throws RemoteException;

	boolean isListType(ListType listType, ClassPropertyId classPropertyId) throws RemoteException;

	int getInstancesSize(ClassId classId, PropertyId propertyId) throws RemoteException;

	Map<ClassId, BidiMap<InstanceId, Integer>> getInstanceIndices() throws RemoteException;

	Map<ClassId, BidiMap<PropertyId, Integer>> getPropertyIndices() throws RemoteException;

	Map<ClassId, Integer> getTableIndeces() throws RemoteException;

	Set<ClassPropertyId> getListTypes() throws RemoteException;

	Set<ClassPropertyId> getListTypes(ListType listType) throws RemoteException;

	Map<ValueId, Object> getValues() throws RemoteException;

	Map<ClassId, PropertyId> getClassKeys() throws RemoteException;

	Map<ClassPropertyId, ColumnDataType> getColumnDataTypes() throws RemoteException;

	Map<ClassPropertyId, Set<InstanceId>> getInstancesPerClassProperty() throws RemoteException;

}
