package de.mannheim.uni.expansion.data.ontology.model;

import java.io.Serializable;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class ClassPropertyId implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private final ClassId classId;
	private final PropertyId propertyId;

	public ClassId getClassId() {
		return classId;
	}

	public PropertyId getPropertyId() {
		return propertyId;
	}

	public ClassPropertyId(ClassId classId, PropertyId propertyId) {
		super();
		this.classId = classId;
		this.propertyId = propertyId;
	}

	public ClassPropertyId(TripleId tripleId) {
		this(tripleId.getClassId(), tripleId.getPropertyId());
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((classId == null) ? 0 : classId.hashCode());
		result = prime * result + ((propertyId == null) ? 0 : propertyId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ClassPropertyId other = (ClassPropertyId) obj;
		if (classId == null) {
			if (other.classId != null)
				return false;
		} else if (!classId.equals(other.classId))
			return false;
		if (propertyId == null) {
			if (other.propertyId != null)
				return false;
		} else if (!propertyId.equals(other.propertyId))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "" + classId + "<>" + propertyId;
	}

}