package de.mannheim.uni.expansion.data.ontology.model.instances;

import java.io.Serializable;

public class InstanceId implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	final private String instance;

	transient private String readableString;

	public InstanceId(String instance) {
		this.instance = instance;
		this.readableString = getReadableString(instance);
	}

	private InstanceId(String instance, String readableString) {
		this.instance = instance;
		this.readableString = readableString;
	}

	public static InstanceId fromString(String s) {
		return new InstanceId("http://dbpedia.org/resource/" + (s).replace(" ", "_"), s);
	}

	@Override
	public String toString() {
		return instance;
	}

	private static int beginIndex = "http://dbpedia.org/resource/".length();

	private String getReadableString(String instanceString) {
		String ret = instanceString.substring(beginIndex).replace("_", " ");
		return ret;
	}

	public String getReadableString() {
		if (readableString == null) {
			this.readableString = getReadableString(instance);
		}
		return readableString;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((instance == null) ? 0 : instance.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		InstanceId other = (InstanceId) obj;
		if (instance == null) {
			if (other.instance != null)
				return false;
		} else if (!instance.equals(other.instance))
			return false;
		return true;
	}

}
