package de.mannheim.uni.expansion.data.ontology.model.properties;

import java.io.Serializable;

public class PropertyId implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private final String property;

	public PropertyId(String property) {
		this.property = property;
	}

	public static PropertyId fromString(String s) {
		return new PropertyId("http://dbpedia.org/ontology/" + (s).replace(" ", "_"));
	}

	@Override
	public String toString() {
		return property;
	}

	public String getAsString() {
		return property;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((property == null) ? 0 : property.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PropertyId other = (PropertyId) obj;
		if (property == null) {
			if (other.property != null)
				return false;
		} else if (!property.equals(other.property))
			return false;
		return true;
	}

	public String getFinalPart() {
		String[] splits = property.split("/");
		return splits[splits.length - 1];
	}

}
