package de.mannheim.uni.expansion.data.tables.repository;

import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableData;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableMetaData;
import de.mannheim.uni.expansion.data.tables.model.HostId;
import de.mannheim.uni.tableprocessor.model.Table;

public interface AnnotatedTablesRepository {

	Set<AnnotatedTableId> ofClass(ClassId dbpediaClass);

	Set<AnnotatedTableId> hasProperty(PropertyId property);

	Set<AnnotatedTableId> hasProperties(Set<PropertyId> properties);

	Set<AnnotatedTableId> hasInstance(InstanceId instances);

	Set<AnnotatedTableId> hasInstances(Set<InstanceId> instances);

	AnnotatedTableMetaData getMetaData(AnnotatedTableId id);

	HostId getHostId(AnnotatedTableId id);

	Table getData(AnnotatedTableId id);

	AnnotatedTableData getData(AnnotatedTableId id, int row);

	Map<AnnotatedTableId, String> getValues(InstanceId instance, PropertyId property);

	Set<InstanceId> getInstances();

	Set<AnnotatedTableId> getAllTableIds();

	Map<Integer, Object> getColumn(AnnotatedTableId id, int columnIndex);

	Object getValue(AnnotatedTableId id, int column, int row);

	Object getKeyValue(AnnotatedTableId id, int row);

	void printStatistics();

}
