package de.mannheim.uni.expansion.data.tables.repository.remote;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableData;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableMetaData;
import de.mannheim.uni.expansion.data.tables.model.HostId;
import de.mannheim.uni.tableprocessor.model.Table;

public interface AnnotatedTablesRepositoryRemote extends Remote {
	Set<AnnotatedTableId> ofClass(ClassId dbpediaClass) throws RemoteException;

	Set<AnnotatedTableId> hasProperty(PropertyId property) throws RemoteException;

	Set<AnnotatedTableId> hasProperties(Set<PropertyId> properties) throws RemoteException;

	Set<AnnotatedTableId> hasInstance(InstanceId instances) throws RemoteException;

	Set<AnnotatedTableId> hasInstances(Set<InstanceId> instances) throws RemoteException;

	AnnotatedTableMetaData getMetaData(AnnotatedTableId id) throws RemoteException;

	Table getData(AnnotatedTableId id) throws RemoteException;

	AnnotatedTableData getData(AnnotatedTableId id, int row) throws RemoteException;

	Map<AnnotatedTableId, String> getValues(InstanceId instance, PropertyId property) throws RemoteException;

	Set<InstanceId> getInstances() throws RemoteException;

	Set<AnnotatedTableId> getAllTableIds() throws RemoteException;

	Map<Integer, Object> getColumn(AnnotatedTableId id, int columnIndex) throws RemoteException;

	Object getValue(AnnotatedTableId id, int column, int row) throws RemoteException;

	Object getKeyValue(AnnotatedTableId id, int row) throws RemoteException;

	HostId getHostId(AnnotatedTableId id) throws RemoteException;
}
