package de.mannheim.uni.expansion.tablefusion.core.similarity;

import java.util.HashMap;
import java.util.Map;

import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

public class Similarity {

	public enum SimilarityType {
		DIRECT, LIST_OVERLAP;

		private static Map<String, SimilarityType> map = new HashMap<>();

		static {
			for (SimilarityType type : SimilarityType.values()) {
				map.put(type.toString(), type);
			}
		}

		public static SimilarityType getFromString(String string) {
			return map.get(string);
		}
	}

	private final double sim;
	private final SimilarityType type;
	private final ColumnDataType cdt;

	public Similarity(double sim, SimilarityType type, ColumnDataType cdt) {
		super();
		this.sim = sim;
		this.type = type;
		this.cdt = cdt;
	}

	public double getSim() {
		return sim;
	}

	public SimilarityType getType() {
		return type;
	}

	public ColumnDataType getCdt() {
		return cdt;
	}

}
