package de.mannheim.uni.expansion.tablefusion.core.similarity.measures;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.similarity.AbstractSimilarity;
import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

public class BooleanSimilarity extends AbstractSimilarity {

	@Inject
	public BooleanSimilarity() {

	}

	@Override
	public double normalSimilarity(Object a, Object b) {
		if (a == null || b == null) {
			return 0.0;
		} else if (!(a instanceof Boolean) || !(b instanceof Boolean)) {
			return 0.0;
		} else {
			boolean v1 = (boolean) a;
			boolean v2 = (boolean) b;

			if (v1 == v2)
				return 1.0;
			else
				return 0.0;
		}
	}

	@Override
	public double getQuickSimilarity(Object a, Object b) {
		return normalSimilarity(a, b);
	}

	@Override
	protected ColumnDataType getColumnDataType() {
		return ColumnDataType.bool;
	}

	@Override
	public double getEquivalenceThreshold() {
		return 0.5;
	}
}
