package de.mannheim.uni.expansion.tablefusion.core.similarity.measures;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.similarity.AbstractSimilarity;
import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

public class ReferenceSimilarity extends AbstractSimilarity {

	@Inject
	public ReferenceSimilarity() {
	}

	@Override
	public double getQuickSimilarity(Object a, Object b) {
		return normalSimilarity(a, b);
	}

	@Override
	public double getEquivalenceThreshold() {
		return 0.99;
	}

	@Override
	protected double normalSimilarity(Object a, Object b) {

		// FIXME: DO Nullcheck somewhere else
		if (a != null && a.equals(b)) {
			return 1.0;
		} else {
			return 0.0;
		}
	}

	@Override
	protected ColumnDataType getColumnDataType() {
		return ColumnDataType.reference;
	}

}
