package de.mannheim.uni.expansion.tablefusion;

import javax.inject.Singleton;

import dagger.Module;
import dagger.Provides;
import de.mannheim.uni.expansion.data.dbpedia.repository.DBpediaRepositoryNewInterface;
import de.mannheim.uni.expansion.data.ontology.model.reader.XMLOntologyReader;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepository;

@Module(includes = { DBpediaModule.class }, library = true)
public class OntologyModule {

	private final String ontologyOwlFile;

	public OntologyModule(String ontologyOwlFile) {
		super();
		this.ontologyOwlFile = ontologyOwlFile;
	}

	@Provides
	@Singleton
	OntologyRepository getOntologyRepository(DBpediaRepositoryNewInterface dBpediaRepositoryNew) {
		XMLOntologyReader reader = new XMLOntologyReader();

		return reader.run(dBpediaRepositoryNew, ontologyOwlFile);
	}

}
