package de.mannheim.uni.expansion.tablefusion;

import javax.inject.Named;

import dagger.Module;
import dagger.Provides;

@Module(library = true)
public class RankingModule {

	private final String hostRankingsFile;
	private final String hostRankingsFileFiltered;

	public RankingModule(String hostRankingsFile, String hostRankingsFileFiltered) {
		super();
		this.hostRankingsFile = hostRankingsFile;
		this.hostRankingsFileFiltered = hostRankingsFileFiltered;
	}

	@Provides
	@Named(NamedProperties.HOST_RANKINGS_FILE)
	String getHostRankingsFile() {
		return this.hostRankingsFile;
	}

	@Provides
	@Named(NamedProperties.HOST_RANKINGS_FILE_FILTERED)
	String getHostRankingsFileFiltered() {
		return this.hostRankingsFileFiltered;
	}

}
