package de.mannheim.uni.expansion.tablefusion;

import java.util.EnumMap;
import java.util.Map;

import javax.inject.Singleton;

import dagger.Module;
import dagger.Provides;
import de.mannheim.uni.expansion.tablefusion.core.similarity.thresholds.SimilarityMeasures;
import de.mannheim.uni.expansion.tablefusion.core.similarity.thresholds.SimilarityThresholdsRepository;
import de.mannheim.uni.expansion.tablefusion.core.similarity.thresholds.SimilarityThresholdsRepositoryImpl;

@Module(includes = { DBpediaModule.class }, library = true)
public class SimilarityModule {

	@Provides
	@Singleton
	public SimilarityThresholdsRepository getSimilarityThresholdsRepository() {

		Map<SimilarityMeasures, Double> map = new EnumMap<>(SimilarityMeasures.class);

		for (SimilarityMeasures sm : SimilarityMeasures.values()) {
			switch (sm) {
			case STRING:
				map.put(sm, 0.76);
				break;
			case NUMERIC:
				map.put(sm, 0.98);
				break;
			case DATE:
				map.put(sm, 0.99999999999);
				break;
			case MATCHING_STRING:
				map.put(sm, 0.51);
				break;
			case MATCHING_NUMERIC:
				map.put(sm, 0.23);
				break;
			case MATCHING_DATE:
				map.put(sm, 0.99999999999);
				break;

			}
		}

		return new SimilarityThresholdsRepositoryImpl(map);
	}
}
