package de.mannheim.uni.expansion.tablefusion.analysis;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import de.mannheim.uni.expansion.data.dbpedia.repository.DBpediaRepositoryNewInterface;
import de.mannheim.uni.expansion.data.ontology.model.TripleId;
import de.mannheim.uni.expansion.data.ontology.model.ValueId;

public class FilteredValues {

	private final int set;
	private final DBpediaRepositoryNewInterface dbBpediaRepository;
	private final double percent;

	public FilteredValues(DBpediaRepositoryNewInterface dbBpediaRepository, double percent, int set) {
		this.dbBpediaRepository = dbBpediaRepository;
		this.percent = percent;
		this.set = set;

	}

	public Set<Object> getFilteredValues(TripleId tid) {

		Object value = dbBpediaRepository.getValue(new ValueId(tid.getInstanceId(), tid.getPropertyId()));
		if (value instanceof List) {

			Set<Object> ret = new HashSet<>();

			@SuppressWarnings("unchecked")
			List<Object> values = (List<Object>) value;

			double filterSize = percent * values.size();

			int currentSet = set;

			int s = (int) Math.round(Math.ceil(filterSize * currentSet));

			int sEnd = (int) Math.round(filterSize * (currentSet + 1));

			for (int i = s; i < sEnd; i++) {
				ret.add(values.get(i));
			}

			return ret;
			// for (Object v : values) {
			//
			// if (s >= sEnd) {
			// currentSet++;
			// sEnd = filterSize * (currentSet + 1);
			// }
			//
			// CHMHelper.getFromMap(filteredValues, currentSet, () -> new
			// HashSet<>()).add(v);
			//
			// s++;
			//
			// }
			//
			// for (Entry<Integer, Set<Object>> e2 : filteredValues.entrySet())
			// {
			// CHMHelper.getFromCHM(creationMap, e2.getKey(), () -> new
			// ConcurrentHashMap<>()).put(tid, e2.getValue());
			//
			// }

		}

		return null;

	}
}