package de.mannheim.uni.expansion.tablefusion.analysis.writer;

import de.mannheim.uni.expansion.tablefusion.analysis.stores.PRFMPerformance;
import de.mannheim.uni.expansion.tablefusion.analysis.stores.PerformancePR;
import de.mannheim.uni.expansion.tablefusion.analysis.stores.performance.PERFMPerformanceI;

public class PerformanceResultsWriter extends AbstractResultsWriter {

	public PerformanceResultsWriter() {
		super();
	}

	@Override
	protected String[] getHeaderLine() {
		String[] headerLine = new String[7];
		headerLine[0] = "Correct";
		headerLine[1] = "Wrong";
		headerLine[2] = "MaxCorrect";
		headerLine[3] = "EPercision";
		headerLine[4] = "ERecall";
		headerLine[5] = "EFMeasure";
		headerLine[6] = "New";
		return headerLine;
	}

	public void write(ResultsCategory rc, String[] prefix, PerformancePR performancePR, PERFMPerformanceI prfmPerformance) {

		if (prfmPerformance == null) {
			prfmPerformance = new PRFMPerformance(0, 0, 0);
		}
		String[] line = new String[7];
		line[0] = String.valueOf(performancePR.getCorrect());
		line[1] = String.valueOf(performancePR.getWrong());
		line[2] = String.valueOf(performancePR.getMaxCorrect());
		line[3] = String.valueOf(prfmPerformance.getPrecision());
		line[4] = String.valueOf(prfmPerformance.getRecall());
		line[5] = String.valueOf(prfmPerformance.getfMeasure());
		line[6] = String.valueOf(performancePR.getNew());

		write(rc, prefix, line);
	}

}
