package de.mannheim.uni.expansion.tablefusion.analysis.writer;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.tablefusion.core.similarity.Similarity.SimilarityType;
import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

public enum ResultsCategory {
	TOTAL(new String[] { "Run" }),
	DATA_TYPE(new String[] { "Run", "DataType" }),
	SIMILARITY_TYPE_PREFIX(new String[] { "Run", "DataType", "SimilarityType" }),
	CLASS_ID(new String[] { "Run", "ClassId" }),
	CLASS_PROPERTY_ID(new String[] { "Run", "DataType", "ClassId", "PropertyId" }),
	CLASS_PROPERTY_ID_WITH_DATASET(new String[] { "DataSet", "Run", "DataType", "ClassId", "PropertyId" });

	private final String[] prefix;

	private ResultsCategory(String[] prefix) {
		this.prefix = prefix;
	}

	public String[] getPrefix() {
		return prefix;
	}

	public static String[] getNormalPrefix(String run) {
		return new String[] { run };
	}

	public static String[] getDataTypePrefix(String run, ColumnDataType cdt) {
		return new String[] { run, cdt.toString() };

	}

	public static String[] getSimilarityTypePrefix(String run, ColumnDataType cdt, SimilarityType simType) {
		return new String[] { run, cdt.toString(), simType.toString() };

	}

	public static String[] getClassIdPrefix(String run, ClassId classId) {
		return new String[] { run, classId.getFinalPart() };
	}

	public static String[] getClassPropertyIdPrefix(String run, ColumnDataType cdt, ClassPropertyId classPropertyId) {
		return new String[] { run, cdt.toString(), classPropertyId.getClassId().getFinalPart(), classPropertyId.getPropertyId().toString() };
	}

	public static String[] getClassPropertyIdWithDatasetPrefix(String dataset, String run, ColumnDataType cdt, ClassPropertyId classPropertyId) {
		return new String[] { dataset, run, cdt.toString(), classPropertyId.getClassId().getFinalPart(), classPropertyId.getPropertyId().getFinalPart() };
	}
}
