package de.mannheim.uni.expansion.tablefusion.core.fusing.impl;

import java.util.concurrent.ThreadLocalRandom;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.fusing.Fuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.stores.FusedValue;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.TableScores;

public class RandomFuser implements Fuser {

	@Inject
	public RandomFuser() {

	}

	@Override
	public FusedValue fuse(MatchedValues values, TableScores probabilities, double threshold) {
		ThreadLocalRandom random = ThreadLocalRandom.current();
		int randomNum = random.nextInt(values.getValues().size());

		return new FusedValue(values.getValues().get(randomNum).getValue(), 1.0);
	}

	@Override
	public FusedValue fuseList(MatchedValues values, TableScores probabilities, double threshold) {
		// TODO Auto-generated method stub
		return null;
	}

}
