package de.mannheim.uni.expansion.tablefusion.core.fusing.impl.generic;

import java.util.List;
import java.util.NoSuchElementException;
import java.util.SortedSet;
import java.util.stream.Collectors;

import de.mannheim.uni.expansion.tablefusion.core.fusing.BaseFuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.ClusterFuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.ClusterFuser.Cluster;
import de.mannheim.uni.expansion.tablefusion.core.fusing.ClusterFuser.ClusterValue;
import de.mannheim.uni.expansion.tablefusion.core.fusing.stores.FusedValue;
import de.mannheim.uni.expansion.tablefusion.core.similarity.SimilarityMeasure;
import de.mannheim.uni.expansion.utils.OtsuThresholder;
import de.mannheim.uni.expansion.utils.ValueProbabilityPair;

@Deprecated
public class AbstractClusterFuser implements BaseFuser {

	private final ClusterFuser clusterFuser;
	private final BaseFuser baseFuser;
	private final SimilarityMeasure similarityMeasure;

	public AbstractClusterFuser(OtsuThresholder otsuThresholder, ClusterFuser clusterFuser, BaseFuser simpleFuser, SimilarityMeasure similarityMeasure) {
		this.clusterFuser = clusterFuser;
		this.baseFuser = simpleFuser;
		this.similarityMeasure = similarityMeasure;

	}

	@Override
	@Deprecated
	public FusedValue simpleFuse(List<Object> values) {

		if (values.size() > 25000) {
			System.out.println("List of Values too large. Not using cluster fusing: " + values.size());

			return baseFuser.simpleFuse(values);
		}

		List<ClusterValue> clusterValues = values.stream().map(e -> {
			return new ClusterValue(e, 1.0);
		}).collect(Collectors.toList());

		try {

			SortedSet<Cluster> clusters = clusterFuser.fuse(clusterValues, baseFuser, similarityMeasure);

			Double max = null;
			Cluster cluster = null;
			for (Cluster c : clusters) {
				if (max == null) {
					cluster = c;
					max = c.getScore();
				} else {
					if (Math.abs(max - c.getScore()) < 0.01) {
						cluster = null;
						max = null;
					}
				}
			}
			if (cluster == null)
				return null;
			else
				// return cluster.getValue();
				return null;
		} catch (NoSuchElementException e) {
			return null;
		}
	}

	@Override
	@Deprecated
	public FusedValue fuse(List<? extends ValueProbabilityPair> values, Double threshold) {
		if (values.size() > 25000) {
			System.out.println("List of Values too large. Not using cluster fusing: " + values.size());

			return baseFuser.fuse(values, threshold);
		}

		List<ClusterValue> clusterValues = values.stream().map(e -> {
			return new ClusterValue(e.getValue(), e.getScore());
		}).collect(Collectors.toList());

		try {
			SortedSet<Cluster> clusters = clusterFuser.fuse(clusterValues, baseFuser, similarityMeasure);

			Double max = null;
			Cluster cluster = null;
			for (Cluster c : clusters) {
				if (max == null) {
					cluster = c;
					max = c.getScore();
				} else {
					if (Math.abs(max - c.getScore()) < 0.001) {
						cluster = null;
						max = null;
					}
				}
			}
			if (cluster == null)
				return null;
			else if (cluster.getScore() > threshold)
				// return cluster.getValue();
				return null;
			else
				return null;
		} catch (NoSuchElementException e) {
			return null;
		}

	}

	@Override
	public boolean checkType(Object value) {
		// TODO Auto-generated method stub
		return false;
	}

}
