package de.mannheim.uni.expansion.tablefusion.core.matching;

import java.util.ArrayList;
import java.util.Collections;

import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

class SynchronizedMatchedValuesCreator extends MatchedValues {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	SynchronizedMatchedValuesCreator(ColumnDataType columnDataType) {
		super(Collections.synchronizedList(new ArrayList<SingleValue>()), columnDataType, true);
	}

	void addSynchronized(MatchedValues mv) {
		this.values.addAll(mv.getValues());
	}

	void addSynchronized(SingleValue sv) {
		this.values.add(sv);
	}

}
