package de.mannheim.uni.expansion.tablefusion.core.matching;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.concurrent.ConcurrentHashMap;

import de.mannheim.uni.expansion.data.ontology.model.TripleId;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues.SingleValue;
import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

public class SynchronizedMatchedValuesMapMerger {

	final ConcurrentHashMap<TripleId, MatchedValues> map = new ConcurrentHashMap<TripleId, MatchedValues>();

	public void merge(Map<TripleId, MatchedValues> m2) {

		for (Entry<TripleId, MatchedValues> e : m2.entrySet()) {

			TripleId mid = e.getKey();
			SynchronizedMatchedValuesCreator smvc = getMatchedValues(mid, e.getValue().getDataType());
			smvc.addSynchronized(e.getValue());

		}

	}

	public void merge(TripleId tid, MatchedValues mv) {

		SynchronizedMatchedValuesCreator smvc = getMatchedValues(tid, mv.getDataType());
		smvc.addSynchronized(mv);

	}

	public SynchronizedMatchedValuesCreator getMatchedValues(TripleId mid, ColumnDataType columnDataType) {

		if (!map.containsKey(mid)) {
			SynchronizedMatchedValuesCreator smvc = new SynchronizedMatchedValuesCreator(columnDataType);

			SynchronizedMatchedValuesCreator previous = (SynchronizedMatchedValuesCreator) map.putIfAbsent(mid, smvc);
			if (previous == null) {
				return smvc;
			} else {
				return previous;
			}

		} else {
			return (SynchronizedMatchedValuesCreator) map.get(mid);
		}

	}

	public Map<TripleId, MatchedValues> getMap() {

		return map;
	}

	public Map<TripleId, MatchedValues> getCleanMap() {

		Map<TripleId, MatchedValues> returnMap = new HashMap<>();
		for (Entry<TripleId, MatchedValues> e : map.entrySet()) {
			returnMap.put(e.getKey(), new MatchedValues(e.getValue()));
		}
		return returnMap;
	}

	public void merge(TripleId tid, SingleValue singleValue, ColumnDataType dataType) {
		SynchronizedMatchedValuesCreator smvc = getMatchedValues(tid, dataType);
		smvc.addSynchronized(singleValue);

	}
}
