package de.mannheim.uni.expansion.tablefusion.core.scoring.packs;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.CellId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;

public interface ScoresContainer {

	public TableScores getTableScores(ClassId classId, PropertyId propertyId, InstanceId instanceId);

	public Probability getScore(ClassId classId, PropertyId propertyId, InstanceId instanceId, AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx);

	public default Probability getScore(ClassId classId, PropertyId propertyId, InstanceId instanceId, CellId cellId) {
		return getScore(classId, propertyId, instanceId, cellId.getTableId(), cellId.getColumnIdx(), cellId.getRowIdx());
	}

	public boolean containsKey(ClassId classId, PropertyId propertyId, InstanceId instanceId, AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx);

	public default boolean containsKey(ClassId classId, PropertyId propertyId, InstanceId instanceId, CellId cellId) {
		return containsKey(classId, propertyId, instanceId, cellId.getTableId(), cellId.getColumnIdx(), cellId.getRowIdx());
	}
}
