package de.mannheim.uni.expansion.tablefusion.core.scoring.packs;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.CellId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;

public interface TableScores {

	Probability get(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx);

	boolean containsKey(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx);

	default Probability get(CellId cellId) {
		return get(cellId.getTableId(), cellId.getColumnIdx(), cellId.getRowIdx());
	}

	default boolean containsKey(CellId cellId) {
		return containsKey(cellId.getTableId(), cellId.getColumnIdx(), cellId.getRowIdx());
	}

	// Set<Entry<AnnotatedTableId, Probability>> entrySet();

	// Set<AnnotatedTableId> keySet();

}
