package de.mannheim.uni.expansion.tablefusion.profiling.accumulation;

import java.util.function.BinaryOperator;

public class AccumInteger implements Accumulateable<AccumInteger> {

	private static final BinaryOperator<AccumInteger> accumulator = (a, b) -> {
		return new AccumInteger(a.get() + b.get());
	};

	private final int val;

	public AccumInteger(int val) {
		this.val = val;
	}

	public int get() {
		return val;
	}

	@Override
	public BinaryOperator<AccumInteger> getAccumulator() {
		return accumulator;
	}

}
