package de.mannheim.uni.expansion.tablefusion.profiling.timestamps;

import de.mannheim.uni.expansion.tablefusion.analysis.writer.GenericAbstractResultsWriter;
import de.mannheim.uni.expansion.tablefusion.analysis.writer.ResultsCategory;

public class TimeStampsAggregatedResultsWriter extends GenericAbstractResultsWriter<TimeStampsAggregatedResults> {

	@Override
	protected String[] getHeaderLine() {
		String[] headerLine = new String[12];
		headerLine[0] = "TotalTables";
		headerLine[1] = "TablesWithHeaderTS";
		headerLine[2] = "TablesWithTableTS";
		headerLine[3] = "TablesWithHT";
		headerLine[4] = "TotalMappedColumns";
		headerLine[5] = "ColWithHeaderTS";
		headerLine[6] = "ColWithTableTS";
		headerLine[7] = "ColWithColumnTS";
		headerLine[8] = "ColWithTC";
		headerLine[9] = "ColWithHT";
		headerLine[10] = "ColWithHC";
		headerLine[11] = "ColWithAllTS";
		return headerLine;
	}

	public void write(ResultsCategory rc, String[] prefix, TimeStampsAggregatedResults results) {

		String[] line = new String[12];
		line[0] = String.valueOf(results.getTotalTables());
		line[1] = String.valueOf(results.getTablesWithHeaderTimestamps());
		line[2] = String.valueOf(results.getTablesWithTableTimestamps());
		line[3] = String.valueOf(results.getTablesHTTimestamps());
		line[4] = String.valueOf(results.getTotalMappedColumns());
		line[5] = String.valueOf(results.getMappedColumnsWithHeaderTimestamp());
		line[6] = String.valueOf(results.getMappedColumnsWithTableTimestamp());
		line[7] = String.valueOf(results.getMappedColumnsWithColumnTimestamp());
		line[8] = String.valueOf(results.getMappedColumnsWithTCTimestamp());
		line[9] = String.valueOf(results.getMappedColumnsWithHTTimestamp());
		line[10] = String.valueOf(results.getMappedColumnsWithHCTimestamp());
		line[11] = String.valueOf(results.getMappedColumnsWithAllTimestamps());

		write(rc, prefix, line);
	}

}
