package de.mannheim.uni.expansion.tablefusion.profiling.timestamps;

import de.mannheim.uni.expansion.tablefusion.analysis.writer.GenericAbstractResultsWriter;
import de.mannheim.uni.expansion.tablefusion.analysis.writer.ResultsCategory;

public class TimeStampsSingleResultsWriter extends GenericAbstractResultsWriter<TimeStampsSingleResults> {

	@Override
	protected String[] getHeaderLine() {
		String[] headerLine = new String[9];
		headerLine[0] = "TotalMappedValues";
		headerLine[1] = "BeforeText";
		headerLine[2] = "AfterText";
		headerLine[3] = "ContextBefore";
		headerLine[4] = "TableTitle";
		headerLine[5] = "PageTitle";
		headerLine[6] = "ColumnHeader";
		headerLine[7] = "RowCell";
		headerLine[8] = "AtLeastOne";
		return headerLine;
	}

	public void write(ResultsCategory rc, String[] prefix, TimeStampsSingleResults results) {

		String[] line = new String[9];
		line[0] = String.valueOf(results.getTotal());
		line[1] = String.valueOf(results.getBeforeText());
		line[2] = String.valueOf(results.getAfterText());
		line[3] = String.valueOf(results.getContextBefore());
		line[4] = String.valueOf(results.getTableTitle());
		line[5] = String.valueOf(results.getPageTitle());
		line[6] = String.valueOf(results.getColumnHeader());
		line[7] = String.valueOf(results.getRowCell());
		line[8] = String.valueOf(results.getAtLeastOne());

		write(rc, prefix, line);
	}

}
