package de.mannheim.uni.expansion.tablefusion.services.fusion.runner;

import de.mannheim.uni.expansion.tablefusion.optimization.ThresholdType;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class FusionStrategy {

	final private String name;
	final private FusionMethod fusionMethod;
	final private Class<? extends Scorer> scoresGetter;
	final private TestingMethod testingMethod;

	final private ThresholdType thresholdType;

	public FusionStrategy(String name, FusionMethod fusionMetehod, TestingMethod testingMethod) {
		super();
		this.name = name;
		this.fusionMethod = fusionMetehod;
		this.testingMethod = testingMethod;
		this.scoresGetter = null;
		this.thresholdType = ThresholdType.General;
	}

	public FusionStrategy(String name, FusionMethod fusionMetehod, TestingMethod testingMethod, Class<? extends Scorer> scoringMethod) {
		super();
		this.name = name;
		this.fusionMethod = fusionMetehod;
		this.testingMethod = testingMethod;
		this.scoresGetter = scoringMethod;
		this.thresholdType = ThresholdType.General;
	}

	public FusionStrategy(String name, FusionMethod fusionMetehod, TestingMethod testingMethod, Class<? extends Scorer> scoringMethod,
			ThresholdType thresholdType) {
		super();
		this.name = name;
		this.fusionMethod = fusionMetehod;
		this.testingMethod = testingMethod;
		this.scoresGetter = scoringMethod;
		this.thresholdType = thresholdType;
	}

	public String getName() {
		return name;
	}

	public FusionMethod getFusionMethod() {
		return fusionMethod;
	}

	public TestingMethod geTestingMethod() {
		return testingMethod;
	}

	public Class<? extends Scorer> getScoringMethod() {
		return scoresGetter;
	}

	public ThresholdType getThresholdType() {
		return thresholdType;
	}

}
