package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.ProbabilitiesCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;

public class Scorer_KBT implements Scorer {

	private final ProbabilitiesCalculator probabilitiesCalculator;

	@Inject
	public Scorer_KBT(ProbabilitiesCalculator probabilitiesCalculator) {
		this.probabilitiesCalculator = probabilitiesCalculator;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		return probabilitiesCalculator.byProperty(learningSet);
	}
}
