package de.mannheim.uni.expansion.utils;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class MapSorter {

	public static <T, E extends Comparable<E>> LinkedHashMap<T, E> sortHashMapByValuesD(Map<T, E> passedMap) {
		List<T> mapKeys = new ArrayList<T>(passedMap.keySet());
		List<E> mapValues = new ArrayList<E>(passedMap.values());
		Collections.sort(mapValues);
		Collections.reverse(mapValues);

		LinkedHashMap<T, E> sortedMap = new LinkedHashMap<T, E>();

		Iterator<E> valueIt = mapValues.iterator();
		while (valueIt.hasNext()) {
			E val = valueIt.next();
			Iterator<T> keyIt = mapKeys.iterator();

			while (keyIt.hasNext()) {
				T key = keyIt.next();
				String comp1 = passedMap.get(key).toString();
				String comp2 = val.toString();

				if (comp1.equals(comp2)) {
					passedMap.remove(key);
					mapKeys.remove(key);
					sortedMap.put(key, val);
					break;
				}

			}

		}
		return sortedMap;
	}

	public static <T extends Comparable<T>, E extends Comparable<E>> LinkedHashMap<T, E> sortHashMapByValuesThenKey(Map<T, E> passedMap) {
		List<T> mapKeys = new ArrayList<T>(passedMap.keySet());
		List<E> mapValues = new ArrayList<E>(passedMap.values());
		Collections.sort(mapValues);
		Collections.reverse(mapValues);
		Collections.sort(mapKeys);

		LinkedHashMap<T, E> sortedMap = new LinkedHashMap<T, E>();

		Iterator<E> valueIt = mapValues.iterator();
		while (valueIt.hasNext()) {
			E val = valueIt.next();
			Iterator<T> keyIt = mapKeys.iterator();

			while (keyIt.hasNext()) {
				T key = keyIt.next();
				String comp1 = passedMap.get(key).toString();
				String comp2 = val.toString();

				if (comp1.equals(comp2)) {
					passedMap.remove(key);
					mapKeys.remove(key);
					sortedMap.put(key, val);
					break;
				}

			}

		}
		return sortedMap;
	}
}
