package de.mannheim.uni.index.dbpedia.abstractIndex;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

import org.apache.lucene.index.IndexWriter;

import com.esotericsoftware.kryo.Kryo;
import com.esotericsoftware.kryo.io.Input;
import com.esotericsoftware.kryo.io.Output;

import de.mannheim.uni.index.IIndex;
import de.mannheim.uni.index.io.DefaultIndex;
import de.mannheim.uni.index.io.StringNormaliser;
import de.mannheim.uni.tableprocessor.IO.TableReader;
import de.mannheim.uni.tableprocessor.model.Table;
import de.mannheim.uni.utils.data.string.StringCleaner;
import java.io.BufferedReader;
import java.io.FileReader;

public class DBpediaAbstractIndexer {

    public void indexInstances(IIndex index, String uri, String abstractText) {

        IndexWriter writer = index.getIndexWriter();

        long cnt = 0;

        DBpediaAbstractIndexEntry e = new DBpediaAbstractIndexEntry();
        e.setUri(uri);
        e.setAbstractText(abstractText);

        try {
            writer.addDocument(e.createDocument());
        } catch (IOException e1) {
            e1.printStackTrace();
        }

        cnt++;

        if (cnt % 100000 == 0) {
            System.out.println("Indexed " + cnt + " items.");
        }
        System.out.println("Indexed " + cnt + " items.");
        index.closeIndexWriter();
    }


public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
        DBpediaAbstractIndexer indexer = new DBpediaAbstractIndexer();

        DefaultIndex idx = new DefaultIndex(args[0]);

        System.out.println("Processing directory");

        BufferedReader read = new BufferedReader(new FileReader(new File(args[1])));
        String line = read.readLine();
        
        while(line != null) {
            String uri = line.split(" <http://dbpedia.org/ontology/abstract> ")[0].replace("<", "").replace(">", "").trim();
            String abstractText = line.split(" <http://dbpedia.org/ontology/abstract> ")[1].replace(".\"@en .", "");
            
            indexer.indexInstances(idx, uri, abstractText);
            line = read.readLine();
        }

        System.out.println("done.");
    }
}
