package de.mannheim.uni.matching.dbpedia.model.adapters;

import java.util.Collection;
import java.util.List;

import de.mannheim.uni.matching.MatchingAdapter;
import de.mannheim.uni.matching.dbpedia.model.TableCell;
import de.mannheim.uni.utils.query.Func;
import de.mannheim.uni.utils.query.Q;

public class TableCellMatchingAdapter extends MatchingAdapter<TableCell> {

	@Override
	public Object getLabel(TableCell instance) {
		return instance.getValue();
	}

	@Override
	public Object getType(TableCell instance) {
		return instance.getType();
	}

	@Override
	public boolean isMultiValued(TableCell instance) {
	    return instance.getValue() instanceof List;
	}
	
	@SuppressWarnings({ "unchecked", "rawtypes" })
    @Override
	public Collection getLabels(TableCell instance) {
	    if(isMultiValued(instance)) {
//	        return (Collection)instance.getValue();
	        //TODO the list should not contain null values, but it does!
	        return Q.where((Collection)instance.getValue(), new Func<Boolean, Object>() {

                @Override
                public Boolean invoke(Object in) {
                    return in != null;
                }
	            
            });
	    } else {
	        return super.getLabels(instance);
	    }
	}
}
