package de.mannheim.uni.matching.dbpedia.model.adapters;

import java.util.Collection;
import java.util.HashSet;

import de.mannheim.uni.matching.MatchingHierarchyAdapater;
import de.mannheim.uni.matching.dbpedia.model.TableCell;
import de.mannheim.uni.matching.dbpedia.model.TableCellCache;
import de.mannheim.uni.matching.dbpedia.model.TableColumnCache;
import de.mannheim.uni.tableprocessor.model.Table;
import de.mannheim.uni.tableprocessor.model.TableColumn;

public class TableColumnToCellHierarchyAdapter extends MatchingHierarchyAdapater<TableColumn, TableCell> {

	@Override
	public Collection<TableCell> getParts(TableColumn instance) {

	    TableColumnCache colCache = TableColumnCache.get();
	    
        Collection<TableCell> cells = colCache.get(instance);
        
	    if(cells==null) {
	    
	        synchronized (instance) {
                
	            if(cells==null) {
	                
	                HashSet<TableCell> cellsTmp = new HashSet<TableCell>(
	                        instance.getValues().size());

	                int colIndex = instance.getTable().getColumns().indexOf(instance);

	                Table t = instance.getTable();
	                TableCellCache cache = TableCellCache.get();

	                for (Integer key : instance.getValues().keySet()) {

	                    TableCell c = cache.getOrCreate(t, key, colIndex);
	                    cellsTmp.add(c);

	                }

	                colCache.set(instance, cellsTmp);
	                
	                
	                cells = cellsTmp;
	            }
	            
            }

	    }
		
		return cells;
	}

}
